﻿// string used for testing in offline mode
var gPageString = "" ;
var gURL = "http://google.com" ;	    
var gArticles = new Array() ;

	    
function initializeMain() {

    System.Gadget.Flyout.file = "flyout.html";

    try {
        var scraper = new WebScraper() ;
        gPageString = scraper.Scrape(gURL) ;
        
        parseDocument() ;
        renderDocument() ;
    } catch ( ex ) {
        displayError( ex.message ) ;
    }
}


function displayError(errorMessage) {
    errorView.innerHTML = errorMessage ;
} 


function parseDocument() {
    
    var titlePattern = "<h3 class=\"entry-header\">(([^<]|.)+?)</h3>" ;
    var bodyPattern = "<div class=\"entry-body\">(([^<]|.)+?)</div>" ;
        
    var matches = new RegexHelper().Matches( gPageString, titlePattern ) ;
    
    var titles = new Array() ;
    for( i=0; i<matches.length; i++ ) {    
        titles[i] = matches[i].Groups[0] ;
    }
    
    matches = new RegexHelper().Matches( gPageString, bodyPattern ) ;
    for( i=0; i<matches.length; i++ ) {    
        var body = matches[i].Groups[0] ;
        var article = new Article(titles[i], body, i) ;
        gArticles[i] = article ;
    }
}


function renderDocument() {

    for( i=0; i<gArticles.length; i++ ) {   
        var article = gArticles[i] ;
        
        var text = document.createTextNode(article.Title);
        var e = document.createElement("li");
        var a = document.createElement("a");
        a.dataIndex = article.Index; // custom prop

        a.attachEvent('onclick', handleClick);

        a.appendChild(text);
        e.appendChild(a);
        myList.appendChild(e);
    }
}


var gSelectedIndex = -1 ;

function handleClick(event){
    var idx = event.srcElement.dataIndex ;
    
    if( idx == gSelectedIndex ) {
        gSelectedIndex = -1 ;
        System.Gadget.Flyout.show = false ;
    }else{
        gSelectedIndex = idx ;
        
        if(System.Gadget.Flyout.show) {
            addContentToFlyout();
        } else {
            System.Gadget.Flyout.show = true;
            System.Gadget.Flyout.onShow = function() {
                addContentToFlyout();
            }
            
            System.Gadget.Flyout.onHide = function() {
                gSelectedIndex = -1 ;
            }
        }
    }
}

function addContentToFlyout() {
    try {
        if(System.Gadget.Flyout.show) {
            var flyoutDoc =  System.Gadget.Flyout.document;
            var article = gArticles[gSelectedIndex] ;
            flyoutDoc.getElementById("title").innerHTML = article.Title ;
            flyoutDoc.getElementById("bodyContent").innerHTML = article.Body ;
        }
    } catch ( ex ) {
        displayError( ex.message ) ;
    }
}



/////////////////////////////////////////////////////////////////////////////
//
//        WEBSCRAPER MODULE
//        Author: Darren Neimke
//
/////////////////////////////////////////////////////////////////////////////

// WebScraper Class    
function WebScraper() {
    var xmlHttp = null;
    
    this.Scrape = function( url ) {
        var html = "" ;
        initializeProxy() ;
        try {
            if (xmlHttp != null) {
                xmlHttp.open("GET", url) ;
                xmlHttp.send(null) ;
                html = xmlHttp.responseText;
            }
        } catch(ex) {
            throw new ErrorObject( ex.message ) ;
        }
        
        return html ;
    }
    
    
    function initializeProxy() {
        xmlHttp = null ;
        if (window.XMLHttpRequest) {
            xmlHttp = new XMLHttpRequest()
        } else if (window.ActiveXObject) {
            xmlHttp = new ActiveXObject("Microsoft.XMLHTTP")
        }
    }
}



/////////////////////////////////////////////////////////////////////////////
//
//        REGEXHELPER MODULE
//
/////////////////////////////////////////////////////////////////////////////

// ErrorObject Class    
function ErrorObject( message ) { this.message = message ; }

// RegexHelper Class    
function RegexHelper() {
    // accepts 2 overloads:
    // - array Matches ( input, pattern )
    // - array Matches ( input, pattern, opts )
    this.Matches = function ( input, pattern, opts ) {
        var re ;
        var results = new Array() ;
        
        try {    
            // overload
            if( arguments.length == 3 )
                re = new RegExp( pattern, opts ) ;
            else
                re = new RegExp( pattern, "gi" ) ;
        } 
        catch ( ex ) { throw new ErrorObject( ex.message ) ; }
        var arr = re.exec(input) ;
        while(arr != null) { 
            var match = new Match() ;
            match.Value = arr[0] ;
                    
            for (var i=0; i<arr.length; i++) {
                match.Groups[i-1] = arr[i] ;
            }
            
            results[results.length] = match ;
            arr = re.exec(input) ; 
        }
        return results ;
    }
    
    
    // accepts 2 overloads:
    // - array Replace ( input, pattern, replacement )
    // - array Replace ( input, pattern, replacement, opts )
    this.Replace = function( input, pattern, replacement, opts ) {
        var re ;
        var retVal = input ;
        
        try {    
            // overload
            if( arguments.length == 3 )
                re = new RegExp( pattern, "gi" ) ;
            else
                re = new RegExp( pattern, opts ) ;
        }  catch ( ex ) { throw new ErrorObject( ex.message ) ; }
            
        while( re.test( retVal ) ) { 
            retVal = retVal.replace( re, replacement ) ;
        }
        return retVal ;
    }
}

// Match Class    
function Match() {
    this.Value = null ;
    this.Groups = new Array() ;
}


function Article(title, body, index) {
    this.Title = title ;
    this.Body = body ;
    this.Index = index ;
}